void pauseAllSources(ALCcontext *ctx){
  ALCcontext *current = alcGetCurrentContext();
  alcMakeContextCurrent(ctx);
  ALsource **src, **src_end;
  src     = ctx->ActiveSources;
  src_end = src + ctx->ActiveSourceCount;
  while(src != src_end){
    if (AL_PLAYING == (*src)->state){
    //if (AL_TRUE){
      ALuint source_id = (*src)->source;
      //printf("pausing ONE source\n");
      alSourcePause(source_id);
    }
    src++;
  }
  alcMakeContextCurrent(current);
}


#define RUNONLY(n)				\
  {static int __runonce = n;			\
    if (__runonce-- <= 0){__runonce = 0;return;}}

#define RUNAT(n)				\
  {static int __runat = n;			\
    if (0 != __runat--){return;}}


#define DsyncSourcei(sourceID1, sourceID2, ctx1, ctx2, param)	\
  {/*printf("synci : " #param "\n");*/				\
    syncSourcei(sourceID1, sourceID2, ctx1, ctx2, param);}

#define DsyncSourcef(sourceID1, sourceID2, ctx1, ctx2, param)	\
  {/*printf("syncf : " #param "\n");*/				\
    syncSourcef(sourceID1, sourceID2, ctx1, ctx2, param);}

#define DsyncSource3i(sourceID1, sourceID2, ctx1, ctx2, param)	\
  {/*printf("sync3i : " #param "\n");*/				\
    syncSource3i(sourceID1, sourceID2, ctx1, ctx2, param);}

#define DsyncSource3f(sourceID1, sourceID2, ctx1, ctx2, param)	\
  {/*printf("sync3f : " #param "\n");*/				\
    syncSource3f(sourceID1, sourceID2, ctx1, ctx2, param);}

void printError(void){
  ALenum error = alGetError();
  printf("%s\n", GetALCErrorString(error));
  printf("%s\n", GetALErrorString(error));
}



char* GetALCErrorString(ALenum err)
{
  switch(err)
    {
    case ALC_NO_ERROR:
      return "AL_NO_ERROR";
      break;

    case ALC_INVALID_DEVICE:
      return "ALC_INVALID_DEVICE";
      break;

    case ALC_INVALID_CONTEXT:
      return "ALC_INVALID_CONTEXT";
      break;

    case ALC_INVALID_ENUM:
      return "ALC_INVALID_ENUM";
      break;

    case ALC_INVALID_VALUE:
      return "ALC_INVALID_VALUE";
      break;

    case ALC_OUT_OF_MEMORY:
      return "ALC_OUT_OF_MEMORY";
      break;
    };
  return "UNknown error.";
}







char* GetALErrorString(ALenum err)
{
  switch(err)
    {
    case AL_NO_ERROR:
      return "AL_NO_ERROR";
      break;

    case AL_INVALID_NAME:
      return "AL_INVALID_NAME";
      break;

    case AL_INVALID_ENUM:
      return "AL_INVALID_ENUM";
      break;

    case AL_INVALID_VALUE:
      return "AL_INVALID_VALUE";
      break;

    case AL_INVALID_OPERATION:
      return "AL_INVALID_OPERATION";
      break;

    case AL_OUT_OF_MEMORY:
      return "AL_OUT_OF_MEMORY";
      break;
    };
  return "UNknown error.";
}




